package airport.saibot.services.pr;

import com.sun.xml.ws.api.SOAPVersion;
import com.sun.xml.ws.api.addressing.AddressingVersion;
import com.sun.xml.ws.api.addressing.WSEndpointReference;
import com.sun.xml.ws.api.message.HeaderList;
import com.sun.xml.ws.api.message.Headers;
import com.sun.xml.ws.developer.JAXWSProperties;
import com.sun.xml.ws.developer.WSBindingProvider;

import javax.annotation.Resource;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;

import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.WebServiceContext;

@WebService(name = "ThoughtfulGreeter", targetNamespace = "saibot.airport/services/pr",
            serviceName = "ThoughtfulGreeterService", portName = "ThoughtfulGreeterSOAP11BindingPort",
            wsdlLocation = "/WEB-INF/wsdl/ThoughtfulGreeterService.wsdl")
@SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
@XmlSeeAlso({ ObjectFactory.class })
public class ThoughtfulGreeterImpl {
    @Resource
    WebServiceContext context;
    public ThoughtfulGreeterImpl() {
    }

    @WebMethod(action = "saibot.airport/services/pr/helloToWorld")
    @Oneway
    public void helloToWorld(@WebParam(name = "requestMessage", partName = "payload",
                                       targetNamespace = "saibot.airport/services/pr") GreetingRequestType payload) {
        System.out.println("Request received; it contains name= "+payload.getName());
        GreetingResponseType response = new GreetingResponseType();
        response.setGreeting("Hello from the world to " + payload.getName());
        callbackToHelloFromWorld(response);
    }
    
    private void callbackToHelloFromWorld(GreetingResponseType greetingResponse) {
        // invoke the generated WebService Proxy to pass back the greeting response
        HeaderList hl = (HeaderList) context.getMessageContext().get(JAXWSProperties.INBOUND_HEADER_LIST_PROPERTY);
        // gets the addressing informations in the SOAP header
        WSEndpointReference reference = hl.getReplyTo(AddressingVersion.W3C, SOAPVersion.SOAP_11);
        String messageId = hl.getMessageID(AddressingVersion.W3C, SOAPVersion.SOAP_11);

        ThoughtfulGreeterService thoughtfulGreeterService = new ThoughtfulGreeterService();
        ThoughtfulGreeterCallback thoughtfulGreeterCallback =
          thoughtfulGreeterService.getThoughtfulGreeterCallbackPort();

        WSBindingProvider bp = (WSBindingProvider) thoughtfulGreeterCallback;
        bp.setAddress(reference.getAddress());
        bp.setOutboundHeaders(Headers.create(AddressingVersion.W3C.relatesToTag, messageId));
        System.out.println("Call back address = "+ reference.getAddress());
        System.out.println("Message id = "+messageId);
        System.out.println("call callback now ************************************************************");

        thoughtfulGreeterCallback.helloFromWorld(greetingResponse);

    }

}
